// components/services/leveldb/public/mojom/leveldb.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_LEVELDB_PUBLIC_MOJOM_LEVELDB_MOJOM_SHARED_H_
#define COMPONENTS_SERVICES_LEVELDB_PUBLIC_MOJOM_LEVELDB_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "components/services/leveldb/public/mojom/leveldb.mojom-shared-internal.h"
#include "components/services/filesystem/public/mojom/directory.mojom-shared.h"
#include "mojo/public/mojom/base/memory_allocator_dump_cross_process_uid.mojom-shared.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace leveldb {
namespace mojom {
class BatchedOperationDataView;

class KeyValueDataView;

class OpenOptionsDataView;

class GetManyRequestDataView;
class GetManyResultDataView;


}  // namespace mojom
}  // namespace leveldb

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::leveldb::mojom::BatchedOperationDataView> {
  using Data = ::leveldb::mojom::internal::BatchedOperation_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::leveldb::mojom::KeyValueDataView> {
  using Data = ::leveldb::mojom::internal::KeyValue_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::leveldb::mojom::OpenOptionsDataView> {
  using Data = ::leveldb::mojom::internal::OpenOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::leveldb::mojom::GetManyRequestDataView> {
  using Data = ::leveldb::mojom::internal::GetManyRequest_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

template <>
struct MojomTypeTraits<::leveldb::mojom::GetManyResultDataView> {
  using Data = ::leveldb::mojom::internal::GetManyResult_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace leveldb {
namespace mojom {


enum class DatabaseError : int32_t {
  
  OK,
  
  NOT_FOUND,
  
  CORRUPTION,
  
  NOT_SUPPORTED,
  
  INVALID_ARGUMENT,
  
  IO_ERROR,
  kMinValue = 0,
  kMaxValue = 5,
};

 std::ostream& operator<<(std::ostream& os, DatabaseError value);
inline bool IsKnownEnumValue(DatabaseError value) {
  return internal::DatabaseError_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class BatchOperationType : int32_t {
  
  PUT_KEY,
  
  DELETE_KEY,
  
  DELETE_PREFIXED_KEY,
  
  COPY_PREFIXED_KEY,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, BatchOperationType value);
inline bool IsKnownEnumValue(BatchOperationType value) {
  return internal::BatchOperationType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class SharedReadCache : int32_t {
  
  Default,
  
  Web,
  kMinValue = 0,
  kMaxValue = 1,
};

 std::ostream& operator<<(std::ostream& os, SharedReadCache value);
inline bool IsKnownEnumValue(SharedReadCache value) {
  return internal::SharedReadCache_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class LevelDBServiceInterfaceBase {};

using LevelDBServicePtrDataView =
    mojo::InterfacePtrDataView<LevelDBServiceInterfaceBase>;
using LevelDBServiceRequestDataView =
    mojo::InterfaceRequestDataView<LevelDBServiceInterfaceBase>;
using LevelDBServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<LevelDBServiceInterfaceBase>;
using LevelDBServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<LevelDBServiceInterfaceBase>;
class LevelDBDatabaseInterfaceBase {};

using LevelDBDatabasePtrDataView =
    mojo::InterfacePtrDataView<LevelDBDatabaseInterfaceBase>;
using LevelDBDatabaseRequestDataView =
    mojo::InterfaceRequestDataView<LevelDBDatabaseInterfaceBase>;
using LevelDBDatabaseAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<LevelDBDatabaseInterfaceBase>;
using LevelDBDatabaseAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<LevelDBDatabaseInterfaceBase>;
class BatchedOperationDataView {
 public:
  BatchedOperationDataView() {}

  BatchedOperationDataView(
      internal::BatchedOperation_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::leveldb::mojom::BatchOperationType>(
        data_value, output);
  }

  BatchOperationType type() const {
    return static_cast<BatchOperationType>(data_->type);
  }
  inline void GetKeyDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::BatchedOperation_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class KeyValueDataView {
 public:
  KeyValueDataView() {}

  KeyValueDataView(
      internal::KeyValue_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeyDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::KeyValue_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class OpenOptionsDataView {
 public:
  OpenOptionsDataView() {}

  OpenOptionsDataView(
      internal::OpenOptions_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool create_if_missing() const {
    return data_->create_if_missing;
  }
  bool error_if_exists() const {
    return data_->error_if_exists;
  }
  bool paranoid_checks() const {
    return data_->paranoid_checks;
  }
  uint64_t write_buffer_size() const {
    return data_->write_buffer_size;
  }
  int32_t max_open_files() const {
    return data_->max_open_files;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSharedBlockReadCache(UserType* output) const {
    auto data_value = data_->shared_block_read_cache;
    return mojo::internal::Deserialize<::leveldb::mojom::SharedReadCache>(
        data_value, output);
  }

  SharedReadCache shared_block_read_cache() const {
    return static_cast<SharedReadCache>(data_->shared_block_read_cache);
  }
 private:
  internal::OpenOptions_Data* data_ = nullptr;
};

class GetManyRequestDataView {
 public:
  using Tag = internal::GetManyRequest_Data::GetManyRequest_Tag;

  GetManyRequestDataView() {}

  GetManyRequestDataView(
      internal::GetManyRequest_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_key_prefix() const { return data_->tag == Tag::KEY_PREFIX; }
  inline void GetKeyPrefixDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyPrefix(UserType* output) {
    DCHECK(is_key_prefix());
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        data_->data.f_key_prefix.Get(), output, context_);
  }
  bool is_key() const { return data_->tag == Tag::KEY; }
  inline void GetKeyDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    DCHECK(is_key());
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        data_->data.f_key.Get(), output, context_);
  }

 private:
  internal::GetManyRequest_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class GetManyResultDataView {
 public:
  using Tag = internal::GetManyResult_Data::GetManyResult_Tag;

  GetManyResultDataView() {}

  GetManyResultDataView(
      internal::GetManyResult_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_status() const { return data_->tag == Tag::STATUS; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    DCHECK(is_status());
    return mojo::internal::Deserialize<::leveldb::mojom::DatabaseError>(
        data_->data.f_status, output);
  }

  DatabaseError status() const {
    DCHECK(is_status());
    return static_cast<DatabaseError>(
        data_->data.f_status);
  }
  bool is_key_prefix_values() const { return data_->tag == Tag::KEY_PREFIX_VALUES; }
  inline void GetKeyPrefixValuesDataView(
      mojo::ArrayDataView<KeyValueDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyPrefixValues(UserType* output) {
    DCHECK(is_key_prefix_values());
    return mojo::internal::Deserialize<mojo::ArrayDataView<::leveldb::mojom::KeyValueDataView>>(
        data_->data.f_key_prefix_values.Get(), output, context_);
  }
  bool is_key_value() const { return data_->tag == Tag::KEY_VALUE; }
  inline void GetKeyValueDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyValue(UserType* output) {
    DCHECK(is_key_value());
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        data_->data.f_key_value.Get(), output, context_);
  }

 private:
  internal::GetManyResult_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace leveldb

namespace std {

template <>
struct hash<::leveldb::mojom::DatabaseError>
    : public mojo::internal::EnumHashImpl<::leveldb::mojom::DatabaseError> {};

template <>
struct hash<::leveldb::mojom::BatchOperationType>
    : public mojo::internal::EnumHashImpl<::leveldb::mojom::BatchOperationType> {};

template <>
struct hash<::leveldb::mojom::SharedReadCache>
    : public mojo::internal::EnumHashImpl<::leveldb::mojom::SharedReadCache> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::leveldb::mojom::DatabaseError, ::leveldb::mojom::DatabaseError> {
  static ::leveldb::mojom::DatabaseError ToMojom(::leveldb::mojom::DatabaseError input) { return input; }
  static bool FromMojom(::leveldb::mojom::DatabaseError input, ::leveldb::mojom::DatabaseError* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::leveldb::mojom::DatabaseError, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::leveldb::mojom::DatabaseError, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::leveldb::mojom::DatabaseError>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::leveldb::mojom::BatchOperationType, ::leveldb::mojom::BatchOperationType> {
  static ::leveldb::mojom::BatchOperationType ToMojom(::leveldb::mojom::BatchOperationType input) { return input; }
  static bool FromMojom(::leveldb::mojom::BatchOperationType input, ::leveldb::mojom::BatchOperationType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::leveldb::mojom::BatchOperationType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::leveldb::mojom::BatchOperationType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::leveldb::mojom::BatchOperationType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::leveldb::mojom::SharedReadCache, ::leveldb::mojom::SharedReadCache> {
  static ::leveldb::mojom::SharedReadCache ToMojom(::leveldb::mojom::SharedReadCache input) { return input; }
  static bool FromMojom(::leveldb::mojom::SharedReadCache input, ::leveldb::mojom::SharedReadCache* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::leveldb::mojom::SharedReadCache, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::leveldb::mojom::SharedReadCache, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::leveldb::mojom::SharedReadCache>(input), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::leveldb::mojom::BatchedOperationDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::leveldb::mojom::BatchedOperationDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::leveldb::mojom::internal::BatchedOperation_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    mojo::internal::Serialize<::leveldb::mojom::BatchOperationType>(
        Traits::type(input), &(*output)->type);
    decltype(Traits::key(input)) in_key = Traits::key(input);
    typename decltype((*output)->key)::BaseType::BufferWriter
        key_writer;
    const mojo::internal::ContainerValidateParams key_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
        in_key, buffer, &key_writer, &key_validate_params,
        context);
    (*output)->key.Set(
        key_writer.is_null() ? nullptr : key_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->key.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null key in BatchedOperation struct");
    decltype(Traits::value(input)) in_value = Traits::value(input);
    typename decltype((*output)->value)::BaseType::BufferWriter
        value_writer;
    const mojo::internal::ContainerValidateParams value_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
        in_value, buffer, &value_writer, &value_validate_params,
        context);
    (*output)->value.Set(
        value_writer.is_null() ? nullptr : value_writer.data());
  }

  static bool Deserialize(::leveldb::mojom::internal::BatchedOperation_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::leveldb::mojom::BatchedOperationDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::leveldb::mojom::KeyValueDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::leveldb::mojom::KeyValueDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::leveldb::mojom::internal::KeyValue_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::key(input)) in_key = Traits::key(input);
    typename decltype((*output)->key)::BaseType::BufferWriter
        key_writer;
    const mojo::internal::ContainerValidateParams key_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
        in_key, buffer, &key_writer, &key_validate_params,
        context);
    (*output)->key.Set(
        key_writer.is_null() ? nullptr : key_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->key.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null key in KeyValue struct");
    decltype(Traits::value(input)) in_value = Traits::value(input);
    typename decltype((*output)->value)::BaseType::BufferWriter
        value_writer;
    const mojo::internal::ContainerValidateParams value_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
        in_value, buffer, &value_writer, &value_validate_params,
        context);
    (*output)->value.Set(
        value_writer.is_null() ? nullptr : value_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->value.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null value in KeyValue struct");
  }

  static bool Deserialize(::leveldb::mojom::internal::KeyValue_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::leveldb::mojom::KeyValueDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::leveldb::mojom::OpenOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::leveldb::mojom::OpenOptionsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::leveldb::mojom::internal::OpenOptions_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->create_if_missing = Traits::create_if_missing(input);
    (*output)->error_if_exists = Traits::error_if_exists(input);
    (*output)->paranoid_checks = Traits::paranoid_checks(input);
    (*output)->write_buffer_size = Traits::write_buffer_size(input);
    (*output)->max_open_files = Traits::max_open_files(input);
    mojo::internal::Serialize<::leveldb::mojom::SharedReadCache>(
        Traits::shared_block_read_cache(input), &(*output)->shared_block_read_cache);
  }

  static bool Deserialize(::leveldb::mojom::internal::OpenOptions_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::leveldb::mojom::OpenOptionsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::leveldb::mojom::GetManyRequestDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::leveldb::mojom::GetManyRequestDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::leveldb::mojom::internal::GetManyRequest_Data::BufferWriter* writer,
                        bool inlined,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
         writer->data()->set_null();
      return;
    }
    if (!inlined)
      writer->Allocate(buffer);

    ::leveldb::mojom::internal::GetManyRequest_Data::BufferWriter& result = *writer;
    ALLOW_UNUSED_LOCAL(result);
    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    result->size = kUnionDataSize;
    result->tag = Traits::GetTag(input);
    switch (result->tag) {
      case ::leveldb::mojom::GetManyRequestDataView::Tag::KEY_PREFIX: {
        decltype(Traits::key_prefix(input))
            in_key_prefix = Traits::key_prefix(input);
        typename decltype(result->data.f_key_prefix)::BaseType::BufferWriter
            value_writer;
        const ContainerValidateParams key_prefix_validate_params(
            0, false, nullptr);
        mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
            in_key_prefix, buffer, &value_writer, &key_prefix_validate_params,
            context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null key_prefix in GetManyRequest union");
        result->data.f_key_prefix.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
      case ::leveldb::mojom::GetManyRequestDataView::Tag::KEY: {
        decltype(Traits::key(input))
            in_key = Traits::key(input);
        typename decltype(result->data.f_key)::BaseType::BufferWriter
            value_writer;
        const ContainerValidateParams key_validate_params(
            0, false, nullptr);
        mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
            in_key, buffer, &value_writer, &key_validate_params,
            context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null key in GetManyRequest union");
        result->data.f_key.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
    }
  }

  static bool Deserialize(::leveldb::mojom::internal::GetManyRequest_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::leveldb::mojom::GetManyRequestDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::leveldb::mojom::GetManyResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::leveldb::mojom::GetManyResultDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::leveldb::mojom::internal::GetManyResult_Data::BufferWriter* writer,
                        bool inlined,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
         writer->data()->set_null();
      return;
    }
    if (!inlined)
      writer->Allocate(buffer);

    ::leveldb::mojom::internal::GetManyResult_Data::BufferWriter& result = *writer;
    ALLOW_UNUSED_LOCAL(result);
    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    result->size = kUnionDataSize;
    result->tag = Traits::GetTag(input);
    switch (result->tag) {
      case ::leveldb::mojom::GetManyResultDataView::Tag::STATUS: {
        decltype(Traits::status(input))
            in_status = Traits::status(input);
        mojo::internal::Serialize<::leveldb::mojom::DatabaseError>(
            in_status, &result->data.f_status);
        break;
      }
      case ::leveldb::mojom::GetManyResultDataView::Tag::KEY_PREFIX_VALUES: {
        decltype(Traits::key_prefix_values(input))
            in_key_prefix_values = Traits::key_prefix_values(input);
        typename decltype(result->data.f_key_prefix_values)::BaseType::BufferWriter
            value_writer;
        const ContainerValidateParams key_prefix_values_validate_params(
            0, false, nullptr);
        mojo::internal::Serialize<mojo::ArrayDataView<::leveldb::mojom::KeyValueDataView>>(
            in_key_prefix_values, buffer, &value_writer, &key_prefix_values_validate_params,
            context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null key_prefix_values in GetManyResult union");
        result->data.f_key_prefix_values.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
      case ::leveldb::mojom::GetManyResultDataView::Tag::KEY_VALUE: {
        decltype(Traits::key_value(input))
            in_key_value = Traits::key_value(input);
        typename decltype(result->data.f_key_value)::BaseType::BufferWriter
            value_writer;
        const ContainerValidateParams key_value_validate_params(
            0, false, nullptr);
        mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
            in_key_value, buffer, &value_writer, &key_value_validate_params,
            context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null key_value in GetManyResult union");
        result->data.f_key_value.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
    }
  }

  static bool Deserialize(::leveldb::mojom::internal::GetManyResult_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::leveldb::mojom::GetManyResultDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace leveldb {
namespace mojom {

inline void BatchedOperationDataView::GetKeyDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->key.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}
inline void BatchedOperationDataView::GetValueDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->value.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void KeyValueDataView::GetKeyDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->key.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}
inline void KeyValueDataView::GetValueDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->value.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}




inline void GetManyRequestDataView::GetKeyPrefixDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  DCHECK(is_key_prefix());
  *output = mojo::ArrayDataView<uint8_t>(data_->data.f_key_prefix.Get(), context_);
}
inline void GetManyRequestDataView::GetKeyDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  DCHECK(is_key());
  *output = mojo::ArrayDataView<uint8_t>(data_->data.f_key.Get(), context_);
}

inline void GetManyResultDataView::GetKeyPrefixValuesDataView(
    mojo::ArrayDataView<KeyValueDataView>* output) {
  DCHECK(is_key_prefix_values());
  *output = mojo::ArrayDataView<KeyValueDataView>(data_->data.f_key_prefix_values.Get(), context_);
}
inline void GetManyResultDataView::GetKeyValueDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  DCHECK(is_key_value());
  *output = mojo::ArrayDataView<uint8_t>(data_->data.f_key_value.Get(), context_);
}


}  // namespace mojom
}  // namespace leveldb

#endif  // COMPONENTS_SERVICES_LEVELDB_PUBLIC_MOJOM_LEVELDB_MOJOM_SHARED_H_