// components/services/leveldb/public/mojom/leveldb.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_LEVELDB_PUBLIC_MOJOM_LEVELDB_MOJOM_H_
#define COMPONENTS_SERVICES_LEVELDB_PUBLIC_MOJOM_LEVELDB_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "components/services/leveldb/public/mojom/leveldb.mojom-shared.h"
#include "components/services/leveldb/public/mojom/leveldb.mojom-forward.h"
#include "components/services/filesystem/public/mojom/directory.mojom.h"
#include "mojo/public/mojom/base/memory_allocator_dump_cross_process_uid.mojom.h"
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/leveldatabase/env_chromium.h"




namespace leveldb {
namespace mojom {

class LevelDBServiceProxy;

template <typename ImplRefTraits>
class LevelDBServiceStub;

class LevelDBServiceRequestValidator;
class LevelDBServiceResponseValidator;


class  LevelDBService
    : public LevelDBServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = true;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = LevelDBServiceInterfaceBase;
  using Proxy_ = LevelDBServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = LevelDBServiceStub<ImplRefTraits>;

  using RequestValidator_ = LevelDBServiceRequestValidator;
  using ResponseValidator_ = LevelDBServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOpenMinVersion = 0,
    kOpenWithOptionsMinVersion = 0,
    kOpenInMemoryMinVersion = 0,
    kDestroyMinVersion = 0,
  };
  virtual ~LevelDBService() {}


  using OpenCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void Open(::filesystem::mojom::DirectoryPtr directory, const std::string& dbname, const base::Optional<::base::trace_event::MemoryAllocatorDumpGuid>& memory_dump_id, mojo::PendingAssociatedReceiver<LevelDBDatabase> database, OpenCallback callback) = 0;


  using OpenWithOptionsCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void OpenWithOptions(const ::leveldb_env::Options& options, ::filesystem::mojom::DirectoryPtr directory, const std::string& dbname, const base::Optional<::base::trace_event::MemoryAllocatorDumpGuid>& memory_dump_id, mojo::PendingAssociatedReceiver<LevelDBDatabase> database, OpenWithOptionsCallback callback) = 0;


  using OpenInMemoryCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void OpenInMemory(const base::Optional<::base::trace_event::MemoryAllocatorDumpGuid>& memory_dump_id, const std::string& tracking_name, mojo::PendingAssociatedReceiver<LevelDBDatabase> database, OpenInMemoryCallback callback) = 0;


  using DestroyCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void Destroy(::filesystem::mojom::DirectoryPtr directory, const std::string& dbname, DestroyCallback callback) = 0;
};

class LevelDBDatabaseProxy;

template <typename ImplRefTraits>
class LevelDBDatabaseStub;

class LevelDBDatabaseRequestValidator;
class LevelDBDatabaseResponseValidator;


class  LevelDBDatabase
    : public LevelDBDatabaseInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = true;

  using Base_ = LevelDBDatabaseInterfaceBase;
  using Proxy_ = LevelDBDatabaseProxy;

  template <typename ImplRefTraits>
  using Stub_ = LevelDBDatabaseStub<ImplRefTraits>;

  using RequestValidator_ = LevelDBDatabaseRequestValidator;
  using ResponseValidator_ = LevelDBDatabaseResponseValidator;
  enum MethodMinVersions : uint32_t {
    kPutMinVersion = 0,
    kDeleteMinVersion = 0,
    kDeletePrefixedMinVersion = 0,
    kRewriteDBMinVersion = 0,
    kWriteMinVersion = 0,
    kGetMinVersion = 0,
    kGetPrefixedMinVersion = 0,
    kGetManyMinVersion = 0,
    kCopyPrefixedMinVersion = 0,
    kGetSnapshotMinVersion = 0,
    kReleaseSnapshotMinVersion = 0,
    kGetFromSnapshotMinVersion = 0,
    kNewIteratorMinVersion = 0,
    kNewIteratorFromSnapshotMinVersion = 0,
    kReleaseIteratorMinVersion = 0,
    kIteratorSeekToFirstMinVersion = 0,
    kIteratorSeekToLastMinVersion = 0,
    kIteratorSeekMinVersion = 0,
    kIteratorNextMinVersion = 0,
    kIteratorPrevMinVersion = 0,
  };
  virtual ~LevelDBDatabase() {}


  using PutCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void Put(const std::vector<uint8_t>& key, const std::vector<uint8_t>& value, PutCallback callback) = 0;


  using DeleteCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void Delete(const std::vector<uint8_t>& key, DeleteCallback callback) = 0;


  using DeletePrefixedCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void DeletePrefixed(const std::vector<uint8_t>& key_prefix, DeletePrefixedCallback callback) = 0;


  using RewriteDBCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void RewriteDB(RewriteDBCallback callback) = 0;


  using WriteCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void Write(std::vector<BatchedOperationPtr> operations, WriteCallback callback) = 0;


  using GetCallback = base::OnceCallback<void(DatabaseError, const std::vector<uint8_t>&)>;
  
  virtual void Get(const std::vector<uint8_t>& key, GetCallback callback) = 0;


  using GetPrefixedCallback = base::OnceCallback<void(DatabaseError, std::vector<KeyValuePtr>)>;
  
  virtual void GetPrefixed(const std::vector<uint8_t>& key_prefix, GetPrefixedCallback callback) = 0;


  using GetManyCallback = base::OnceCallback<void(std::vector<GetManyResultPtr>)>;
  
  virtual void GetMany(std::vector<GetManyRequestPtr> keys_or_prefixes, GetManyCallback callback) = 0;


  using CopyPrefixedCallback = base::OnceCallback<void(DatabaseError)>;
  
  virtual void CopyPrefixed(const std::vector<uint8_t>& source_key_prefix, const std::vector<uint8_t>& destination_key_prefix, CopyPrefixedCallback callback) = 0;


  using GetSnapshotCallback = base::OnceCallback<void(const ::base::UnguessableToken&)>;
  
  virtual void GetSnapshot(GetSnapshotCallback callback) = 0;

  
  virtual void ReleaseSnapshot(const ::base::UnguessableToken& snapshot) = 0;


  using GetFromSnapshotCallback = base::OnceCallback<void(DatabaseError, const std::vector<uint8_t>&)>;
  
  virtual void GetFromSnapshot(const ::base::UnguessableToken& snapshot, const std::vector<uint8_t>& key, GetFromSnapshotCallback callback) = 0;


  using NewIteratorCallback = base::OnceCallback<void(const ::base::UnguessableToken&)>;
  
  virtual void NewIterator(NewIteratorCallback callback) = 0;


  using NewIteratorFromSnapshotCallback = base::OnceCallback<void(const base::Optional<::base::UnguessableToken>&)>;
  
  virtual void NewIteratorFromSnapshot(const ::base::UnguessableToken& snapshot, NewIteratorFromSnapshotCallback callback) = 0;

  
  virtual void ReleaseIterator(const ::base::UnguessableToken& iterator) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool IteratorSeekToFirst(const ::base::UnguessableToken& iterator, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value);

  using IteratorSeekToFirstCallback = base::OnceCallback<void(bool, DatabaseError, const base::Optional<std::vector<uint8_t>>&, const base::Optional<std::vector<uint8_t>>&)>;
  
  virtual void IteratorSeekToFirst(const ::base::UnguessableToken& iterator, IteratorSeekToFirstCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool IteratorSeekToLast(const ::base::UnguessableToken& iterator, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value);

  using IteratorSeekToLastCallback = base::OnceCallback<void(bool, DatabaseError, const base::Optional<std::vector<uint8_t>>&, const base::Optional<std::vector<uint8_t>>&)>;
  
  virtual void IteratorSeekToLast(const ::base::UnguessableToken& iterator, IteratorSeekToLastCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool IteratorSeek(const ::base::UnguessableToken& iterator, const std::vector<uint8_t>& target, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value);

  using IteratorSeekCallback = base::OnceCallback<void(bool, DatabaseError, const base::Optional<std::vector<uint8_t>>&, const base::Optional<std::vector<uint8_t>>&)>;
  
  virtual void IteratorSeek(const ::base::UnguessableToken& iterator, const std::vector<uint8_t>& target, IteratorSeekCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool IteratorNext(const ::base::UnguessableToken& iterator, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value);

  using IteratorNextCallback = base::OnceCallback<void(bool, DatabaseError, const base::Optional<std::vector<uint8_t>>&, const base::Optional<std::vector<uint8_t>>&)>;
  
  virtual void IteratorNext(const ::base::UnguessableToken& iterator, IteratorNextCallback callback) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool IteratorPrev(const ::base::UnguessableToken& iterator, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value);

  using IteratorPrevCallback = base::OnceCallback<void(bool, DatabaseError, const base::Optional<std::vector<uint8_t>>&, const base::Optional<std::vector<uint8_t>>&)>;
  
  virtual void IteratorPrev(const ::base::UnguessableToken& iterator, IteratorPrevCallback callback) = 0;
};



class  LevelDBServiceProxy
    : public LevelDBService {
 public:
  using InterfaceType = LevelDBService;

  explicit LevelDBServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Open(::filesystem::mojom::DirectoryPtr directory, const std::string& dbname, const base::Optional<::base::trace_event::MemoryAllocatorDumpGuid>& memory_dump_id, mojo::PendingAssociatedReceiver<LevelDBDatabase> database, OpenCallback callback) final;
  
  void OpenWithOptions(const ::leveldb_env::Options& options, ::filesystem::mojom::DirectoryPtr directory, const std::string& dbname, const base::Optional<::base::trace_event::MemoryAllocatorDumpGuid>& memory_dump_id, mojo::PendingAssociatedReceiver<LevelDBDatabase> database, OpenWithOptionsCallback callback) final;
  
  void OpenInMemory(const base::Optional<::base::trace_event::MemoryAllocatorDumpGuid>& memory_dump_id, const std::string& tracking_name, mojo::PendingAssociatedReceiver<LevelDBDatabase> database, OpenInMemoryCallback callback) final;
  
  void Destroy(::filesystem::mojom::DirectoryPtr directory, const std::string& dbname, DestroyCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  LevelDBDatabaseProxy
    : public LevelDBDatabase {
 public:
  using InterfaceType = LevelDBDatabase;

  explicit LevelDBDatabaseProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Put(const std::vector<uint8_t>& key, const std::vector<uint8_t>& value, PutCallback callback) final;
  
  void Delete(const std::vector<uint8_t>& key, DeleteCallback callback) final;
  
  void DeletePrefixed(const std::vector<uint8_t>& key_prefix, DeletePrefixedCallback callback) final;
  
  void RewriteDB(RewriteDBCallback callback) final;
  
  void Write(std::vector<BatchedOperationPtr> operations, WriteCallback callback) final;
  
  void Get(const std::vector<uint8_t>& key, GetCallback callback) final;
  
  void GetPrefixed(const std::vector<uint8_t>& key_prefix, GetPrefixedCallback callback) final;
  
  void GetMany(std::vector<GetManyRequestPtr> keys_or_prefixes, GetManyCallback callback) final;
  
  void CopyPrefixed(const std::vector<uint8_t>& source_key_prefix, const std::vector<uint8_t>& destination_key_prefix, CopyPrefixedCallback callback) final;
  
  void GetSnapshot(GetSnapshotCallback callback) final;
  
  void ReleaseSnapshot(const ::base::UnguessableToken& snapshot) final;
  
  void GetFromSnapshot(const ::base::UnguessableToken& snapshot, const std::vector<uint8_t>& key, GetFromSnapshotCallback callback) final;
  
  void NewIterator(NewIteratorCallback callback) final;
  
  void NewIteratorFromSnapshot(const ::base::UnguessableToken& snapshot, NewIteratorFromSnapshotCallback callback) final;
  
  void ReleaseIterator(const ::base::UnguessableToken& iterator) final;
  
  bool IteratorSeekToFirst(const ::base::UnguessableToken& iterator, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value) final;
  
  void IteratorSeekToFirst(const ::base::UnguessableToken& iterator, IteratorSeekToFirstCallback callback) final;
  
  bool IteratorSeekToLast(const ::base::UnguessableToken& iterator, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value) final;
  
  void IteratorSeekToLast(const ::base::UnguessableToken& iterator, IteratorSeekToLastCallback callback) final;
  
  bool IteratorSeek(const ::base::UnguessableToken& iterator, const std::vector<uint8_t>& target, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value) final;
  
  void IteratorSeek(const ::base::UnguessableToken& iterator, const std::vector<uint8_t>& target, IteratorSeekCallback callback) final;
  
  bool IteratorNext(const ::base::UnguessableToken& iterator, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value) final;
  
  void IteratorNext(const ::base::UnguessableToken& iterator, IteratorNextCallback callback) final;
  
  bool IteratorPrev(const ::base::UnguessableToken& iterator, bool* out_valid, DatabaseError* out_status, base::Optional<std::vector<uint8_t>>* out_key, base::Optional<std::vector<uint8_t>>* out_value) final;
  
  void IteratorPrev(const ::base::UnguessableToken& iterator, IteratorPrevCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  LevelDBServiceStubDispatch {
 public:
  static bool Accept(LevelDBService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      LevelDBService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<LevelDBService>>
class LevelDBServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  LevelDBServiceStub() {}
  ~LevelDBServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LevelDBServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LevelDBServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  LevelDBDatabaseStubDispatch {
 public:
  static bool Accept(LevelDBDatabase* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      LevelDBDatabase* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<LevelDBDatabase>>
class LevelDBDatabaseStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  LevelDBDatabaseStub() {}
  ~LevelDBDatabaseStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LevelDBDatabaseStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LevelDBDatabaseStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  LevelDBServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  LevelDBDatabaseRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  LevelDBServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  LevelDBDatabaseResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class  GetManyRequest {
 public:
  using DataView = GetManyRequestDataView;
  using Data_ = internal::GetManyRequest_Data;
  using Tag = Data_::GetManyRequest_Tag;

  static GetManyRequestPtr New() {
    return GetManyRequestPtr(base::in_place);
  }
  // Construct an instance holding |key_prefix|.
  static GetManyRequestPtr
  NewKeyPrefix(
      const std::vector<uint8_t>& key_prefix) {
    auto result = GetManyRequestPtr(base::in_place);
    result->set_key_prefix(std::move(key_prefix));
    return result;
  }
  // Construct an instance holding |key|.
  static GetManyRequestPtr
  NewKey(
      const std::vector<uint8_t>& key) {
    auto result = GetManyRequestPtr(base::in_place);
    result->set_key(std::move(key));
    return result;
  }

  template <typename U>
  static GetManyRequestPtr From(const U& u) {
    return mojo::TypeConverter<GetManyRequestPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GetManyRequest>::Convert(*this);
  }

  GetManyRequest();
  ~GetManyRequest();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = GetManyRequestPtr>
  GetManyRequestPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, GetManyRequest>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_key_prefix() const { return tag_ == Tag::KEY_PREFIX; }

  
  std::vector<uint8_t>& get_key_prefix() const {
    DCHECK(tag_ == Tag::KEY_PREFIX);
    return *(data_.key_prefix);
  }

  
  void set_key_prefix(
      const std::vector<uint8_t>& key_prefix);
  
  bool is_key() const { return tag_ == Tag::KEY; }

  
  std::vector<uint8_t>& get_key() const {
    DCHECK(tag_ == Tag::KEY);
    return *(data_.key);
  }

  
  void set_key(
      const std::vector<uint8_t>& key);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GetManyRequest::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<GetManyRequest::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

 private:
  union Union_ {
    Union_() {}
    ~Union_() {}
    std::vector<uint8_t>* key_prefix;
    std::vector<uint8_t>* key;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};



class  GetManyResult {
 public:
  using DataView = GetManyResultDataView;
  using Data_ = internal::GetManyResult_Data;
  using Tag = Data_::GetManyResult_Tag;

  static GetManyResultPtr New() {
    return GetManyResultPtr(base::in_place);
  }
  // Construct an instance holding |status|.
  static GetManyResultPtr
  NewStatus(
      DatabaseError status) {
    auto result = GetManyResultPtr(base::in_place);
    result->set_status(std::move(status));
    return result;
  }
  // Construct an instance holding |key_prefix_values|.
  static GetManyResultPtr
  NewKeyPrefixValues(
      std::vector<KeyValuePtr> key_prefix_values) {
    auto result = GetManyResultPtr(base::in_place);
    result->set_key_prefix_values(std::move(key_prefix_values));
    return result;
  }
  // Construct an instance holding |key_value|.
  static GetManyResultPtr
  NewKeyValue(
      const std::vector<uint8_t>& key_value) {
    auto result = GetManyResultPtr(base::in_place);
    result->set_key_value(std::move(key_value));
    return result;
  }

  template <typename U>
  static GetManyResultPtr From(const U& u) {
    return mojo::TypeConverter<GetManyResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GetManyResult>::Convert(*this);
  }

  GetManyResult();
  ~GetManyResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = GetManyResultPtr>
  GetManyResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, GetManyResult>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_status() const { return tag_ == Tag::STATUS; }

  
  DatabaseError get_status() const {
    DCHECK(tag_ == Tag::STATUS);
    return data_.status;
  }

  
  void set_status(
      DatabaseError status);
  
  bool is_key_prefix_values() const { return tag_ == Tag::KEY_PREFIX_VALUES; }

  
  std::vector<KeyValuePtr>& get_key_prefix_values() const {
    DCHECK(tag_ == Tag::KEY_PREFIX_VALUES);
    return *(data_.key_prefix_values);
  }

  
  void set_key_prefix_values(
      std::vector<KeyValuePtr> key_prefix_values);
  
  bool is_key_value() const { return tag_ == Tag::KEY_VALUE; }

  
  std::vector<uint8_t>& get_key_value() const {
    DCHECK(tag_ == Tag::KEY_VALUE);
    return *(data_.key_value);
  }

  
  void set_key_value(
      const std::vector<uint8_t>& key_value);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GetManyResult::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<GetManyResult::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

 private:
  union Union_ {
    Union_() {}
    ~Union_() {}
    DatabaseError status;
    std::vector<KeyValuePtr>* key_prefix_values;
    std::vector<uint8_t>* key_value;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class  BatchedOperation {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BatchedOperation, T>::value>;
  using DataView = BatchedOperationDataView;
  using Data_ = internal::BatchedOperation_Data;

  template <typename... Args>
  static BatchedOperationPtr New(Args&&... args) {
    return BatchedOperationPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BatchedOperationPtr From(const U& u) {
    return mojo::TypeConverter<BatchedOperationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BatchedOperation>::Convert(*this);
  }


  BatchedOperation();

  BatchedOperation(
      BatchOperationType type,
      const std::vector<uint8_t>& key,
      const base::Optional<std::vector<uint8_t>>& value);

  ~BatchedOperation();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BatchedOperationPtr>
  BatchedOperationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BatchedOperation::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BatchedOperation::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BatchedOperation::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BatchedOperation_UnserializedMessageContext<
            UserType, BatchedOperation::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<BatchedOperation::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BatchedOperation::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BatchedOperation_UnserializedMessageContext<
            UserType, BatchedOperation::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BatchedOperation::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  BatchOperationType type;
  
  std::vector<uint8_t> key;
  
  base::Optional<std::vector<uint8_t>> value;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BatchedOperation::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BatchedOperation::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BatchedOperation::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BatchedOperation::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  KeyValue {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<KeyValue, T>::value>;
  using DataView = KeyValueDataView;
  using Data_ = internal::KeyValue_Data;

  template <typename... Args>
  static KeyValuePtr New(Args&&... args) {
    return KeyValuePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static KeyValuePtr From(const U& u) {
    return mojo::TypeConverter<KeyValuePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, KeyValue>::Convert(*this);
  }


  KeyValue();

  KeyValue(
      const std::vector<uint8_t>& key,
      const std::vector<uint8_t>& value);

  ~KeyValue();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = KeyValuePtr>
  KeyValuePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, KeyValue::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        KeyValue::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        KeyValue::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::KeyValue_UnserializedMessageContext<
            UserType, KeyValue::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<KeyValue::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return KeyValue::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::KeyValue_UnserializedMessageContext<
            UserType, KeyValue::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<KeyValue::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<uint8_t> key;
  
  std::vector<uint8_t> value;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, KeyValue::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, KeyValue::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, KeyValue::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, KeyValue::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  OpenOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<OpenOptions, T>::value>;
  using DataView = OpenOptionsDataView;
  using Data_ = internal::OpenOptions_Data;

  template <typename... Args>
  static OpenOptionsPtr New(Args&&... args) {
    return OpenOptionsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static OpenOptionsPtr From(const U& u) {
    return mojo::TypeConverter<OpenOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, OpenOptions>::Convert(*this);
  }


  OpenOptions();

  OpenOptions(
      bool create_if_missing,
      bool error_if_exists,
      bool paranoid_checks,
      uint64_t write_buffer_size,
      int32_t max_open_files,
      SharedReadCache shared_block_read_cache);

  ~OpenOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = OpenOptionsPtr>
  OpenOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, OpenOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        OpenOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        OpenOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::OpenOptions_UnserializedMessageContext<
            UserType, OpenOptions::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<OpenOptions::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return OpenOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::OpenOptions_UnserializedMessageContext<
            UserType, OpenOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<OpenOptions::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  bool create_if_missing;
  
  bool error_if_exists;
  
  bool paranoid_checks;
  
  uint64_t write_buffer_size;
  
  int32_t max_open_files;
  
  SharedReadCache shared_block_read_cache;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, OpenOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, OpenOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, OpenOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, OpenOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
GetManyRequestPtr GetManyRequest::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::KEY_PREFIX:
      rv->set_key_prefix(mojo::Clone(*data_.key_prefix));
      break;
    case Tag::KEY:
      rv->set_key(mojo::Clone(*data_.key));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, GetManyRequest>::value>::type*>
bool GetManyRequest::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::KEY_PREFIX:
      return mojo::Equals(*(data_.key_prefix), *(other.data_.key_prefix));
    case Tag::KEY:
      return mojo::Equals(*(data_.key), *(other.data_.key));
  }

  return false;
}
template <typename UnionPtrType>
GetManyResultPtr GetManyResult::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::STATUS:
      rv->set_status(mojo::Clone(data_.status));
      break;
    case Tag::KEY_PREFIX_VALUES:
      rv->set_key_prefix_values(mojo::Clone(*data_.key_prefix_values));
      break;
    case Tag::KEY_VALUE:
      rv->set_key_value(mojo::Clone(*data_.key_value));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, GetManyResult>::value>::type*>
bool GetManyResult::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::STATUS:
      return mojo::Equals(data_.status, other.data_.status);
    case Tag::KEY_PREFIX_VALUES:
      return mojo::Equals(*(data_.key_prefix_values), *(other.data_.key_prefix_values));
    case Tag::KEY_VALUE:
      return mojo::Equals(*(data_.key_value), *(other.data_.key_value));
  }

  return false;
}
template <typename StructPtrType>
BatchedOperationPtr BatchedOperation::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(key),
      mojo::Clone(value)
  );
}

template <typename T, BatchedOperation::EnableIfSame<T>*>
bool BatchedOperation::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->key, other_struct.key))
    return false;
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, BatchedOperation::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.key < rhs.key)
    return true;
  if (rhs.key < lhs.key)
    return false;
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
KeyValuePtr KeyValue::Clone() const {
  return New(
      mojo::Clone(key),
      mojo::Clone(value)
  );
}

template <typename T, KeyValue::EnableIfSame<T>*>
bool KeyValue::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->key, other_struct.key))
    return false;
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, KeyValue::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.key < rhs.key)
    return true;
  if (rhs.key < lhs.key)
    return false;
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}
template <typename StructPtrType>
OpenOptionsPtr OpenOptions::Clone() const {
  return New(
      mojo::Clone(create_if_missing),
      mojo::Clone(error_if_exists),
      mojo::Clone(paranoid_checks),
      mojo::Clone(write_buffer_size),
      mojo::Clone(max_open_files),
      mojo::Clone(shared_block_read_cache)
  );
}

template <typename T, OpenOptions::EnableIfSame<T>*>
bool OpenOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->create_if_missing, other_struct.create_if_missing))
    return false;
  if (!mojo::Equals(this->error_if_exists, other_struct.error_if_exists))
    return false;
  if (!mojo::Equals(this->paranoid_checks, other_struct.paranoid_checks))
    return false;
  if (!mojo::Equals(this->write_buffer_size, other_struct.write_buffer_size))
    return false;
  if (!mojo::Equals(this->max_open_files, other_struct.max_open_files))
    return false;
  if (!mojo::Equals(this->shared_block_read_cache, other_struct.shared_block_read_cache))
    return false;
  return true;
}

template <typename T, OpenOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.create_if_missing < rhs.create_if_missing)
    return true;
  if (rhs.create_if_missing < lhs.create_if_missing)
    return false;
  if (lhs.error_if_exists < rhs.error_if_exists)
    return true;
  if (rhs.error_if_exists < lhs.error_if_exists)
    return false;
  if (lhs.paranoid_checks < rhs.paranoid_checks)
    return true;
  if (rhs.paranoid_checks < lhs.paranoid_checks)
    return false;
  if (lhs.write_buffer_size < rhs.write_buffer_size)
    return true;
  if (rhs.write_buffer_size < lhs.write_buffer_size)
    return false;
  if (lhs.max_open_files < rhs.max_open_files)
    return true;
  if (rhs.max_open_files < lhs.max_open_files)
    return false;
  if (lhs.shared_block_read_cache < rhs.shared_block_read_cache)
    return true;
  if (rhs.shared_block_read_cache < lhs.shared_block_read_cache)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace leveldb

namespace mojo {


template <>
struct  StructTraits<::leveldb::mojom::BatchedOperation::DataView,
                                         ::leveldb::mojom::BatchedOperationPtr> {
  static bool IsNull(const ::leveldb::mojom::BatchedOperationPtr& input) { return !input; }
  static void SetToNull(::leveldb::mojom::BatchedOperationPtr* output) { output->reset(); }

  static decltype(::leveldb::mojom::BatchedOperation::type) type(
      const ::leveldb::mojom::BatchedOperationPtr& input) {
    return input->type;
  }

  static const decltype(::leveldb::mojom::BatchedOperation::key)& key(
      const ::leveldb::mojom::BatchedOperationPtr& input) {
    return input->key;
  }

  static const decltype(::leveldb::mojom::BatchedOperation::value)& value(
      const ::leveldb::mojom::BatchedOperationPtr& input) {
    return input->value;
  }

  static bool Read(::leveldb::mojom::BatchedOperation::DataView input, ::leveldb::mojom::BatchedOperationPtr* output);
};


template <>
struct  StructTraits<::leveldb::mojom::KeyValue::DataView,
                                         ::leveldb::mojom::KeyValuePtr> {
  static bool IsNull(const ::leveldb::mojom::KeyValuePtr& input) { return !input; }
  static void SetToNull(::leveldb::mojom::KeyValuePtr* output) { output->reset(); }

  static const decltype(::leveldb::mojom::KeyValue::key)& key(
      const ::leveldb::mojom::KeyValuePtr& input) {
    return input->key;
  }

  static const decltype(::leveldb::mojom::KeyValue::value)& value(
      const ::leveldb::mojom::KeyValuePtr& input) {
    return input->value;
  }

  static bool Read(::leveldb::mojom::KeyValue::DataView input, ::leveldb::mojom::KeyValuePtr* output);
};


template <>
struct  StructTraits<::leveldb::mojom::OpenOptions::DataView,
                                         ::leveldb::mojom::OpenOptionsPtr> {
  static bool IsNull(const ::leveldb::mojom::OpenOptionsPtr& input) { return !input; }
  static void SetToNull(::leveldb::mojom::OpenOptionsPtr* output) { output->reset(); }

  static decltype(::leveldb::mojom::OpenOptions::create_if_missing) create_if_missing(
      const ::leveldb::mojom::OpenOptionsPtr& input) {
    return input->create_if_missing;
  }

  static decltype(::leveldb::mojom::OpenOptions::error_if_exists) error_if_exists(
      const ::leveldb::mojom::OpenOptionsPtr& input) {
    return input->error_if_exists;
  }

  static decltype(::leveldb::mojom::OpenOptions::paranoid_checks) paranoid_checks(
      const ::leveldb::mojom::OpenOptionsPtr& input) {
    return input->paranoid_checks;
  }

  static decltype(::leveldb::mojom::OpenOptions::write_buffer_size) write_buffer_size(
      const ::leveldb::mojom::OpenOptionsPtr& input) {
    return input->write_buffer_size;
  }

  static decltype(::leveldb::mojom::OpenOptions::max_open_files) max_open_files(
      const ::leveldb::mojom::OpenOptionsPtr& input) {
    return input->max_open_files;
  }

  static decltype(::leveldb::mojom::OpenOptions::shared_block_read_cache) shared_block_read_cache(
      const ::leveldb::mojom::OpenOptionsPtr& input) {
    return input->shared_block_read_cache;
  }

  static bool Read(::leveldb::mojom::OpenOptions::DataView input, ::leveldb::mojom::OpenOptionsPtr* output);
};


template <>
struct  UnionTraits<::leveldb::mojom::GetManyRequest::DataView,
                                        ::leveldb::mojom::GetManyRequestPtr> {
  static bool IsNull(const ::leveldb::mojom::GetManyRequestPtr& input) { return !input; }
  static void SetToNull(::leveldb::mojom::GetManyRequestPtr* output) { output->reset(); }

  static ::leveldb::mojom::GetManyRequest::Tag GetTag(const ::leveldb::mojom::GetManyRequestPtr& input) {
    return input->which();
  }

  static const std::vector<uint8_t>& key_prefix(const ::leveldb::mojom::GetManyRequestPtr& input) {
    return input->get_key_prefix();
  }

  static const std::vector<uint8_t>& key(const ::leveldb::mojom::GetManyRequestPtr& input) {
    return input->get_key();
  }

  static bool Read(::leveldb::mojom::GetManyRequest::DataView input, ::leveldb::mojom::GetManyRequestPtr* output);
};


template <>
struct  UnionTraits<::leveldb::mojom::GetManyResult::DataView,
                                        ::leveldb::mojom::GetManyResultPtr> {
  static bool IsNull(const ::leveldb::mojom::GetManyResultPtr& input) { return !input; }
  static void SetToNull(::leveldb::mojom::GetManyResultPtr* output) { output->reset(); }

  static ::leveldb::mojom::GetManyResult::Tag GetTag(const ::leveldb::mojom::GetManyResultPtr& input) {
    return input->which();
  }

  static  ::leveldb::mojom::DatabaseError status(const ::leveldb::mojom::GetManyResultPtr& input) {
    return input->get_status();
  }

  static const std::vector<::leveldb::mojom::KeyValuePtr>& key_prefix_values(const ::leveldb::mojom::GetManyResultPtr& input) {
    return input->get_key_prefix_values();
  }

  static const std::vector<uint8_t>& key_value(const ::leveldb::mojom::GetManyResultPtr& input) {
    return input->get_key_value();
  }

  static bool Read(::leveldb::mojom::GetManyResult::DataView input, ::leveldb::mojom::GetManyResultPtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_LEVELDB_PUBLIC_MOJOM_LEVELDB_MOJOM_H_